/*
 * Copyright (c) 2002, 2003  Brian S. Dean <bsd@bsdhome.com>
 * All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY BRIAN S. DEAN ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL BRIAN S. DEAN BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 */


#ifndef __ringbuf_h__
#define __ringbuf_h__

#include <inttypes.h>

#define RINGBUF_STRUCT(BITS) \
typedef struct ringbuf##BITS##_t {\
  uint16_t   buflen;\
  uint16_t   bufcnt;\
  uint##BITS##_t  * in;\
  uint##BITS##_t  * out;\
  uint##BITS##_t  * buf;\
} RINGBUF##BITS;


#define RINGBUF_PROTO(BITS) \
void           ringbuf##BITS##_init (RINGBUF##BITS * r, uint##BITS##_t * buf,\
                                     uint16_t buflen);\
void           ringbuf##BITS##_put  (RINGBUF##BITS * r, uint##BITS##_t c);\
uint##BITS##_t ringbuf##BITS##_get  (RINGBUF##BITS * r);\
uint##BITS##_t ringbuf##BITS##_look (RINGBUF##BITS * r);

RINGBUF_STRUCT(8)

RINGBUF_STRUCT(16)

RINGBUF_PROTO(8)

RINGBUF_PROTO(16)

#endif
